"""
    UltraCart Rest API V2

    UltraCart REST API Version 2  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@ultracart.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ultracart.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from ultracart.exceptions import ApiAttributeError


def lazy_import():
    from ultracart.model.cart_affiliate import CartAffiliate
    from ultracart.model.cart_billing import CartBilling
    from ultracart.model.cart_buysafe import CartBuysafe
    from ultracart.model.cart_checkout import CartCheckout
    from ultracart.model.cart_coupon import CartCoupon
    from ultracart.model.cart_currency_conversion import CartCurrencyConversion
    from ultracart.model.cart_customer_profile import CartCustomerProfile
    from ultracart.model.cart_gift import CartGift
    from ultracart.model.cart_gift_certificate import CartGiftCertificate
    from ultracart.model.cart_item import CartItem
    from ultracart.model.cart_marketing import CartMarketing
    from ultracart.model.cart_payment import CartPayment
    from ultracart.model.cart_property import CartProperty
    from ultracart.model.cart_settings import CartSettings
    from ultracart.model.cart_shipping import CartShipping
    from ultracart.model.cart_summary import CartSummary
    from ultracart.model.cart_taxes import CartTaxes
    from ultracart.model.cart_upsell_after import CartUpsellAfter
    globals()['CartAffiliate'] = CartAffiliate
    globals()['CartBilling'] = CartBilling
    globals()['CartBuysafe'] = CartBuysafe
    globals()['CartCheckout'] = CartCheckout
    globals()['CartCoupon'] = CartCoupon
    globals()['CartCurrencyConversion'] = CartCurrencyConversion
    globals()['CartCustomerProfile'] = CartCustomerProfile
    globals()['CartGift'] = CartGift
    globals()['CartGiftCertificate'] = CartGiftCertificate
    globals()['CartItem'] = CartItem
    globals()['CartMarketing'] = CartMarketing
    globals()['CartPayment'] = CartPayment
    globals()['CartProperty'] = CartProperty
    globals()['CartSettings'] = CartSettings
    globals()['CartShipping'] = CartShipping
    globals()['CartSummary'] = CartSummary
    globals()['CartTaxes'] = CartTaxes
    globals()['CartUpsellAfter'] = CartUpsellAfter


class Cart(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('base_currency_code',): {
            'max_length': 3,
        },
        ('currency_code',): {
            'max_length': 3,
        },
        ('language_iso_code',): {
            'max_length': 3,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'affiliate': (CartAffiliate,),  # noqa: E501
            'affiliate_network_pixel_oid': (int,),  # noqa: E501
            'base_currency_code': (str,),  # noqa: E501
            'billing': (CartBilling,),  # noqa: E501
            'buysafe': (CartBuysafe,),  # noqa: E501
            'cart_id': (str,),  # noqa: E501
            'checkout': (CartCheckout,),  # noqa: E501
            'coupons': ([CartCoupon],),  # noqa: E501
            'currency_code': (str,),  # noqa: E501
            'currency_conversion': (CartCurrencyConversion,),  # noqa: E501
            'customer_profile': (CartCustomerProfile,),  # noqa: E501
            'exchange_rate': (float,),  # noqa: E501
            'gift': (CartGift,),  # noqa: E501
            'gift_certificate': (CartGiftCertificate,),  # noqa: E501
            'items': ([CartItem],),  # noqa: E501
            'language_iso_code': (str,),  # noqa: E501
            'logged_in': (bool,),  # noqa: E501
            'marketing': (CartMarketing,),  # noqa: E501
            'merchant_id': (str,),  # noqa: E501
            'payment': (CartPayment,),  # noqa: E501
            'properties': ([CartProperty],),  # noqa: E501
            'settings': (CartSettings,),  # noqa: E501
            'shipping': (CartShipping,),  # noqa: E501
            'summary': (CartSummary,),  # noqa: E501
            'taxes': (CartTaxes,),  # noqa: E501
            'upsell_after': (CartUpsellAfter,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'affiliate': 'affiliate',  # noqa: E501
        'affiliate_network_pixel_oid': 'affiliate_network_pixel_oid',  # noqa: E501
        'base_currency_code': 'base_currency_code',  # noqa: E501
        'billing': 'billing',  # noqa: E501
        'buysafe': 'buysafe',  # noqa: E501
        'cart_id': 'cart_id',  # noqa: E501
        'checkout': 'checkout',  # noqa: E501
        'coupons': 'coupons',  # noqa: E501
        'currency_code': 'currency_code',  # noqa: E501
        'currency_conversion': 'currency_conversion',  # noqa: E501
        'customer_profile': 'customer_profile',  # noqa: E501
        'exchange_rate': 'exchange_rate',  # noqa: E501
        'gift': 'gift',  # noqa: E501
        'gift_certificate': 'gift_certificate',  # noqa: E501
        'items': 'items',  # noqa: E501
        'language_iso_code': 'language_iso_code',  # noqa: E501
        'logged_in': 'logged_in',  # noqa: E501
        'marketing': 'marketing',  # noqa: E501
        'merchant_id': 'merchant_id',  # noqa: E501
        'payment': 'payment',  # noqa: E501
        'properties': 'properties',  # noqa: E501
        'settings': 'settings',  # noqa: E501
        'shipping': 'shipping',  # noqa: E501
        'summary': 'summary',  # noqa: E501
        'taxes': 'taxes',  # noqa: E501
        'upsell_after': 'upsell_after',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Cart - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            affiliate (CartAffiliate): [optional]  # noqa: E501
            affiliate_network_pixel_oid (int): The affiliate network pixel identifier associated with the cart. [optional]  # noqa: E501
            base_currency_code (str): The ISO-4217 three letter base currency code of the account. [optional]  # noqa: E501
            billing (CartBilling): [optional]  # noqa: E501
            buysafe (CartBuysafe): [optional]  # noqa: E501
            cart_id (str): Unique identifier for this cart. [optional]  # noqa: E501
            checkout (CartCheckout): [optional]  # noqa: E501
            coupons ([CartCoupon]): Coupons. [optional]  # noqa: E501
            currency_code (str): The ISO-4217 three letter currency code the customer is viewing prices in. [optional]  # noqa: E501
            currency_conversion (CartCurrencyConversion): [optional]  # noqa: E501
            customer_profile (CartCustomerProfile): [optional]  # noqa: E501
            exchange_rate (float): The exchange rate if the customer is viewing a different currency than the base. [optional]  # noqa: E501
            gift (CartGift): [optional]  # noqa: E501
            gift_certificate (CartGiftCertificate): [optional]  # noqa: E501
            items ([CartItem]): Items. [optional]  # noqa: E501
            language_iso_code (str): The ISO-631 three letter code the customer would like to checkout with. [optional]  # noqa: E501
            logged_in (bool): True if the customer is logged into their profile. [optional]  # noqa: E501
            marketing (CartMarketing): [optional]  # noqa: E501
            merchant_id (str): Merchant ID this cart is associated with. [optional]  # noqa: E501
            payment (CartPayment): [optional]  # noqa: E501
            properties ([CartProperty]): Properties associated with the cart. [optional]  # noqa: E501
            settings (CartSettings): [optional]  # noqa: E501
            shipping (CartShipping): [optional]  # noqa: E501
            summary (CartSummary): [optional]  # noqa: E501
            taxes (CartTaxes): [optional]  # noqa: E501
            upsell_after (CartUpsellAfter): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Cart - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            affiliate (CartAffiliate): [optional]  # noqa: E501
            affiliate_network_pixel_oid (int): The affiliate network pixel identifier associated with the cart. [optional]  # noqa: E501
            base_currency_code (str): The ISO-4217 three letter base currency code of the account. [optional]  # noqa: E501
            billing (CartBilling): [optional]  # noqa: E501
            buysafe (CartBuysafe): [optional]  # noqa: E501
            cart_id (str): Unique identifier for this cart. [optional]  # noqa: E501
            checkout (CartCheckout): [optional]  # noqa: E501
            coupons ([CartCoupon]): Coupons. [optional]  # noqa: E501
            currency_code (str): The ISO-4217 three letter currency code the customer is viewing prices in. [optional]  # noqa: E501
            currency_conversion (CartCurrencyConversion): [optional]  # noqa: E501
            customer_profile (CartCustomerProfile): [optional]  # noqa: E501
            exchange_rate (float): The exchange rate if the customer is viewing a different currency than the base. [optional]  # noqa: E501
            gift (CartGift): [optional]  # noqa: E501
            gift_certificate (CartGiftCertificate): [optional]  # noqa: E501
            items ([CartItem]): Items. [optional]  # noqa: E501
            language_iso_code (str): The ISO-631 three letter code the customer would like to checkout with. [optional]  # noqa: E501
            logged_in (bool): True if the customer is logged into their profile. [optional]  # noqa: E501
            marketing (CartMarketing): [optional]  # noqa: E501
            merchant_id (str): Merchant ID this cart is associated with. [optional]  # noqa: E501
            payment (CartPayment): [optional]  # noqa: E501
            properties ([CartProperty]): Properties associated with the cart. [optional]  # noqa: E501
            settings (CartSettings): [optional]  # noqa: E501
            shipping (CartShipping): [optional]  # noqa: E501
            summary (CartSummary): [optional]  # noqa: E501
            taxes (CartTaxes): [optional]  # noqa: E501
            upsell_after (CartUpsellAfter): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
