"""
    UltraCart Rest API V2

    UltraCart REST API Version 2  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@ultracart.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ultracart.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from ultracart.exceptions import ApiAttributeError


def lazy_import():
    from ultracart.model.item_auto_order_step_arbitrary_unit_cost_schedule import ItemAutoOrderStepArbitraryUnitCostSchedule
    from ultracart.model.item_auto_order_step_grandfather_pricing import ItemAutoOrderStepGrandfatherPricing
    globals()['ItemAutoOrderStepArbitraryUnitCostSchedule'] = ItemAutoOrderStepArbitraryUnitCostSchedule
    globals()['ItemAutoOrderStepGrandfatherPricing'] = ItemAutoOrderStepGrandfatherPricing


class ItemAutoOrderStep(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'ITEM': "item",
            'PAUSE': "pause",
            'LOOP': "loop",
            'KIT_ONLY': "kit only",
        },
    }

    validations = {
        ('recurring_merchant_item_id',): {
            'max_length': 20,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'arbitrary_schedule_days': (int,),  # noqa: E501
            'arbitrary_unit_cost': (float,),  # noqa: E501
            'arbitrary_unit_cost_schedules': ([ItemAutoOrderStepArbitraryUnitCostSchedule],),  # noqa: E501
            'grandfather_pricing': ([ItemAutoOrderStepGrandfatherPricing],),  # noqa: E501
            'managed_by': (str,),  # noqa: E501
            'pause_days': (int,),  # noqa: E501
            'pause_until_date': (str,),  # noqa: E501
            'preshipment_notice_days': (int,),  # noqa: E501
            'recurring_merchant_item_id': (str,),  # noqa: E501
            'recurring_merchant_item_oid': (int,),  # noqa: E501
            'repeat_count': (int,),  # noqa: E501
            'schedule': (str,),  # noqa: E501
            'subscribe_email_list_name': (str,),  # noqa: E501
            'subscribe_email_list_oid': (int,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'arbitrary_schedule_days': 'arbitrary_schedule_days',  # noqa: E501
        'arbitrary_unit_cost': 'arbitrary_unit_cost',  # noqa: E501
        'arbitrary_unit_cost_schedules': 'arbitrary_unit_cost_schedules',  # noqa: E501
        'grandfather_pricing': 'grandfather_pricing',  # noqa: E501
        'managed_by': 'managed_by',  # noqa: E501
        'pause_days': 'pause_days',  # noqa: E501
        'pause_until_date': 'pause_until_date',  # noqa: E501
        'preshipment_notice_days': 'preshipment_notice_days',  # noqa: E501
        'recurring_merchant_item_id': 'recurring_merchant_item_id',  # noqa: E501
        'recurring_merchant_item_oid': 'recurring_merchant_item_oid',  # noqa: E501
        'repeat_count': 'repeat_count',  # noqa: E501
        'schedule': 'schedule',  # noqa: E501
        'subscribe_email_list_name': 'subscribe_email_list_name',  # noqa: E501
        'subscribe_email_list_oid': 'subscribe_email_list_oid',  # noqa: E501
        'type': 'type',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ItemAutoOrderStep - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            arbitrary_schedule_days (int): If the schedule is arbitrary, then this is the number of days. [optional]  # noqa: E501
            arbitrary_unit_cost (float): Arbitrary unit cost used to override the regular item cost. [optional]  # noqa: E501
            arbitrary_unit_cost_schedules ([ItemAutoOrderStepArbitraryUnitCostSchedule]): Arbitrary unit costs schedules for more advanced discounting by rebill attempt. [optional]  # noqa: E501
            grandfather_pricing ([ItemAutoOrderStepGrandfatherPricing]): Grand-father pricing configuration if the rebill schedule has changed over time. [optional]  # noqa: E501
            managed_by (str): Managed by (defaults to UltraCart). [optional]  # noqa: E501
            pause_days (int): Number of days to pause. [optional]  # noqa: E501
            pause_until_date (str): Wait for this step to happen until the specified date. [optional]  # noqa: E501
            preshipment_notice_days (int): If set, a pre-shipment notice is sent to the customer this many days in advance. [optional]  # noqa: E501
            recurring_merchant_item_id (str): Item id to rebill. [optional]  # noqa: E501
            recurring_merchant_item_oid (int): Item object identifier to rebill. [optional]  # noqa: E501
            repeat_count (int): Number of times to rebill.  Last step can be null for infinite. [optional]  # noqa: E501
            schedule (str): Frequency of the rebill. [optional]  # noqa: E501
            subscribe_email_list_name (str): Email list name to subscribe the customer to when the rebill occurs. [optional]  # noqa: E501
            subscribe_email_list_oid (int): Email list identifier to subscribe the customer to when this rebill occurs. [optional]  # noqa: E501
            type (str): Type of step (item, kit only, loop or pause). [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ItemAutoOrderStep - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            arbitrary_schedule_days (int): If the schedule is arbitrary, then this is the number of days. [optional]  # noqa: E501
            arbitrary_unit_cost (float): Arbitrary unit cost used to override the regular item cost. [optional]  # noqa: E501
            arbitrary_unit_cost_schedules ([ItemAutoOrderStepArbitraryUnitCostSchedule]): Arbitrary unit costs schedules for more advanced discounting by rebill attempt. [optional]  # noqa: E501
            grandfather_pricing ([ItemAutoOrderStepGrandfatherPricing]): Grand-father pricing configuration if the rebill schedule has changed over time. [optional]  # noqa: E501
            managed_by (str): Managed by (defaults to UltraCart). [optional]  # noqa: E501
            pause_days (int): Number of days to pause. [optional]  # noqa: E501
            pause_until_date (str): Wait for this step to happen until the specified date. [optional]  # noqa: E501
            preshipment_notice_days (int): If set, a pre-shipment notice is sent to the customer this many days in advance. [optional]  # noqa: E501
            recurring_merchant_item_id (str): Item id to rebill. [optional]  # noqa: E501
            recurring_merchant_item_oid (int): Item object identifier to rebill. [optional]  # noqa: E501
            repeat_count (int): Number of times to rebill.  Last step can be null for infinite. [optional]  # noqa: E501
            schedule (str): Frequency of the rebill. [optional]  # noqa: E501
            subscribe_email_list_name (str): Email list name to subscribe the customer to when the rebill occurs. [optional]  # noqa: E501
            subscribe_email_list_oid (int): Email list identifier to subscribe the customer to when this rebill occurs. [optional]  # noqa: E501
            type (str): Type of step (item, kit only, loop or pause). [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
